diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/CMakeLists.txt ns-3.47/src/applications/CMakeLists.txt
--- ns-3.46/src/applications/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/CMakeLists.txt	2026-02-16 16:08:49.569229800 -0800
@@ -12,11 +12,15 @@
     model/onoff-application.cc
     model/packet-loss-counter.cc
     model/packet-sink.cc
+    model/rta-tig-mobile-gaming.cc
     model/seq-ts-echo-header.cc
     model/seq-ts-header.cc
     model/seq-ts-size-header.cc
     model/sink-application.cc
     model/source-application.cc
+    model/tgax-video-traffic.cc
+    model/tgax-virtual-desktop.cc
+    model/tgax-voip-traffic.cc
     model/three-gpp-http-client.cc
     model/three-gpp-http-header.cc
     model/three-gpp-http-server.cc
@@ -38,11 +42,15 @@
     model/onoff-application.h
     model/packet-loss-counter.h
     model/packet-sink.h
+    model/rta-tig-mobile-gaming.h
     model/seq-ts-echo-header.h
     model/seq-ts-header.h
     model/seq-ts-size-header.h
     model/sink-application.h
     model/source-application.h
+    model/tgax-video-traffic.h
+    model/tgax-virtual-desktop.h
+    model/tgax-voip-traffic.h
     model/three-gpp-http-client.h
     model/three-gpp-http-header.h
     model/three-gpp-http-server.h
@@ -57,4 +65,9 @@
     test/three-gpp-http-client-server-test.cc
     test/bulk-send-application-test-suite.cc
     test/udp-client-server-test.cc
+    test/tgax-video-traffic-test-suite.cc
+    test/tgax-voip-traffic-test-suite.cc
+    test/tgax-virtual-desktop-test-suite.cc
+    test/rta-tig-mobile-gaming-test-suite.cc
+  GENERATE_EXPORT_HEADER
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/doc/rta-tig-mobile-gaming-traffic.inc ns-3.47/src/applications/doc/rta-tig-mobile-gaming-traffic.inc
--- ns-3.46/src/applications/doc/rta-tig-mobile-gaming-traffic.inc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/doc/rta-tig-mobile-gaming-traffic.inc	2026-02-16 16:08:49.569229800 -0800
@@ -0,0 +1,296 @@
+RTA TIG Mobile Gaming Traffic Model
+-----------------------------------
+
+This section describes the implementation of the |ns3| Real-Time Applications (RTA) Task
+Interest Group (TIG) mobile gaming traffic generator model, which is based on the
+IEEE 802.11-18/2009r6 RTA TIG Report [RTA-TIG]_.
+
+The RTA TIG mobile gaming traffic model is implemented in the ``src/applications/`` folder.
+
+Real-time mobile gaming is characterized by small packets (30-500 bytes) transmitted
+frequently (every 30-60ms) with strict latency requirements. The traffic is asymmetric
+and bidirectional, with different characteristics for uplink (player commands) and
+downlink (game state updates).
+
+The model uses the Largest Extreme Value (LEV) distribution for packet inter-arrival
+times and packet sizes during the gaming stage, with uniform distributions for initial
+and ending packets.
+
+Scope and Limitations
+~~~~~~~~~~~~~~~~~~~~~
+
+The mobile gaming model implements the traffic generation aspects of the IEEE 802.11-18/2009r6
+specification (Section 4.1.4).
+
+**Supported Features:**
+
+- Two synchronization mechanisms: Status Sync and Frame Lockstep Sync
+- Three-stage traffic model: Initial, Gaming, and Ending
+- Largest Extreme Value distribution for packet arrivals and sizes
+- Uniform distribution for initial and end packet sizes
+- UDP protocol (default, matching specification)
+- Configurable parameters for all four scenarios (DL/UL x Status-Sync/Lockstep)
+- Trace source with stage information
+
+**Known Limitations:**
+
+- Each application instance is unidirectional; bidirectional gaming simulation requires
+  two separate application instances
+- No preset configuration enum; users must manually configure parameters for non-default
+  scenarios
+
+Model Description
+~~~~~~~~~~~~~~~~~
+
+The ``RtaTigMobileGaming`` application is a source application that generates real-time
+mobile gaming traffic patterns according to the IEEE 802.11-18/2009r6 RTA TIG Report.
+
+**Traffic Stages:**
+
+The model implements a three-stage traffic pattern:
+
+1. **INITIAL Stage**: A single packet is sent with size drawn from a uniform distribution.
+   This represents the initial game setup/synchronization packet.
+
+2. **GAMING Stage**: Continuous packet transmission during active gameplay. Packet sizes
+   and inter-arrival times are drawn from Largest Extreme Value distributions.
+
+3. **ENDING Stage**: A single packet is sent when the application stops, with size drawn
+   from a uniform distribution. This represents the game termination packet.
+
+**Synchronization Mechanisms:**
+
+The specification defines two traffic models for different game synchronization approaches:
+
+*Status Sync Model:*
+
+Used by games that synchronize game state between clients and server. Characterized by
+smaller, more frequent packets.
+
+.. list-table:: Status Sync Traffic Parameters
+   :header-rows: 1
+
+   * - Component
+     - Distribution
+     - DL (a, b)
+     - UL (a, b)
+   * - Initial packet size
+     - Uniform
+     - [0, 20] bytes
+     - [0, 20] bytes
+   * - Packet arrival time
+     - Largest Extreme Value
+     - a=13ms, b=3.7ms
+     - a=15ms, b=5.7ms
+   * - Packet size
+     - Largest Extreme Value
+     - a=50, b=11 bytes
+     - a=38, b=3.7 bytes
+   * - End packet size
+     - Uniform
+     - [500, 600] bytes
+     - [400, 550] bytes
+
+*Frame Lockstep Sync Model:*
+
+Used by games that require frame-by-frame synchronization. Characterized by larger
+packets with slightly longer intervals.
+
+.. list-table:: Frame Lockstep Sync Traffic Parameters
+   :header-rows: 1
+
+   * - Component
+     - Distribution
+     - DL (a, b)
+     - UL (a, b)
+   * - Initial packet size
+     - Uniform
+     - [0, 80] bytes
+     - [0, 80] bytes
+   * - Packet arrival time
+     - Largest Extreme Value
+     - a=28ms, b=4.2ms
+     - a=22ms, b=3.4ms
+   * - Packet size
+     - Largest Extreme Value
+     - a=210, b=35 bytes
+     - a=92, b=38 bytes
+   * - End packet size
+     - Uniform
+     - [1400, 1500] bytes
+     - [500, 600] bytes
+
+In the Largest Extreme Value distribution, **a** is the location parameter and **b** is
+the scale parameter.
+
+Configuration and Usage
+***********************
+
+The mobile gaming traffic generator can be instantiated through the ``ApplicationHelper``.
+The default configuration matches the Status-Sync Downlink parameters.
+
+**Default Configuration (Status-Sync DL):**
+
+::
+
+  // Create nodes
+  NodeContainer nodes;
+  nodes.Create(2);
+
+  // Install Internet stack and assign IP addresses
+  InternetStackHelper internet;
+  internet.Install(nodes);
+
+  Ipv4AddressHelper ipv4;
+  ipv4.SetBase("10.0.0.0", "255.255.255.0");
+  ipv4.Assign(devices);
+
+  // Configure gaming application (defaults to status-sync DL)
+  ApplicationHelper sourceHelper(RtaTigMobileGaming::GetTypeId());
+  sourceHelper.SetAttribute("Remote", AddressValue(InetSocketAddress(Ipv4Address("10.0.0.2"), 5000)));
+
+  auto sourceApps = sourceHelper.Install(nodes.Get(0));
+  sourceApps.Start(Seconds(1.0));
+  sourceApps.Stop(Seconds(11.0));
+
+  // Create receiver
+  PacketSinkHelper sinkHelper("ns3::UdpSocketFactory", InetSocketAddress(Ipv4Address::GetAny(), 5000));
+  auto sinkApps = sinkHelper.Install(nodes.Get(1));
+  sinkApps.Start(Seconds(0.0));
+  sinkApps.Stop(Seconds(12.0));
+
+**Lockstep DL Configuration:**
+
+Note:  The below would be better configured via a mode attribute such as LOCKSTEP_DL.
+
+::
+
+  ApplicationHelper sourceHelper(RtaTigMobileGaming::GetTypeId());
+  sourceHelper.SetAttribute("Remote", AddressValue(InetSocketAddress(Ipv4Address("10.0.0.2"), 5000)));
+
+  // Configure lockstep DL parameters
+  auto ips = CreateObjectWithAttributes<UniformRandomVariable>(
+      "Min", DoubleValue(0), "Max", DoubleValue(80));
+  sourceHelper.SetAttribute("InitialPacketSize", PointerValue(ips));
+
+  auto eps = CreateObjectWithAttributes<UniformRandomVariable>(
+      "Min", DoubleValue(1400), "Max", DoubleValue(1500));
+  sourceHelper.SetAttribute("EndPacketSize", PointerValue(eps));
+
+  auto pal = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>(
+      "Location", DoubleValue(28000),   // 28ms in microseconds
+      "Scale", DoubleValue(4200));      // 4.2ms in microseconds
+  sourceHelper.SetAttribute("PacketArrivalLev", PointerValue(pal));
+
+  auto psl = CreateObjectWithAttributes<LargestExtremeValueRandomVariable>(
+      "Location", DoubleValue(210),
+      "Scale", DoubleValue(35));
+  sourceHelper.SetAttribute("PacketSizeLev", PointerValue(psl));
+
+Attributes
+~~~~~~~~~~
+
+The mobile gaming traffic generator uses UDP by default, as specified for in-game data
+in the IEEE specification.
+
+The following attributes control the behavior of the traffic generator:
+
+**Protocol Configuration:**
+
+* ``Protocol``: The socket factory type to use. Default: ``ns3::UdpSocketFactory``
+* ``Remote``: The remote address and port for the gaming traffic destination
+
+**Initial and End Packet Parameters:**
+
+* ``InitialPacketSize``: A uniform random variable for initial packet size in bytes.
+  Default: Uniform[0, 20]
+* ``EndPacketSize``: A uniform random variable for end packet size in bytes.
+  Default: Uniform[500, 600]
+
+**Gaming Stage Parameters:**
+
+* ``PacketArrivalLev``: A Largest Extreme Value random variable for packet inter-arrival
+  times in microseconds. Default: LEV(Location=13000, Scale=3700) (13ms, 3.7ms)
+* ``PacketSizeLev``: A Largest Extreme Value random variable for gaming packet sizes
+  in bytes. Default: LEV(Location=50, Scale=11)
+
+Trace Sources
+~~~~~~~~~~~~~
+
+The mobile gaming traffic generator provides a trace source for monitoring simulation
+behavior:
+
+**TxWithStage:**
+
+::
+
+  typedef void (*TxTracedCallback)(Ptr<const Packet> packet, TrafficModelStage stage);
+
+This trace source is fired when a packet is transmitted. It provides the packet and
+the current traffic model stage (INITIAL, GAMING, or ENDING). This is useful for
+analyzing traffic patterns and verifying stage transitions.
+
+Examples
+~~~~~~~~
+
+The ``rta-tig-mobile-gaming-example.cc`` program demonstrates usage of the mobile gaming
+traffic generator. This example sets up a simple Wi-Fi network (AP and STA) with gaming
+traffic. The example supports all four traffic model presets.
+
+To run with Status-Sync Downlink (default):
+
+::
+
+  $ ./ns3 run rta-tig-mobile-gaming-example
+
+To run with Status-Sync Uplink:
+
+::
+
+  $ ./ns3 run "rta-tig-mobile-gaming-example --model=status-sync-ul"
+
+To run with Frame Lockstep Downlink:
+
+::
+
+  $ ./ns3 run "rta-tig-mobile-gaming-example --model=lockstep-dl"
+
+To run with Frame Lockstep Uplink:
+
+::
+
+  $ ./ns3 run "rta-tig-mobile-gaming-example --model=lockstep-ul"
+
+Tests
+~~~~~
+
+Unit tests for the mobile gaming traffic model are provided in
+``src/applications/test/rta-tig-mobile-gaming-test-suite.cc``. These tests verify:
+
+* Correct stage transitions (INITIAL -> GAMING -> ENDING)
+* Initial packet size within expected bounds
+* End packet size within expected bounds
+* Average gaming packet size matches LEV distribution mean
+* Average packet inter-arrival time matches LEV distribution mean
+* All transmitted bytes are received
+
+To run the mobile gaming traffic tests:
+
+::
+
+  $ ./test.py -s applications-rta-tig-mobile-gaming
+
+Verification
+~~~~~~~~~~~~
+
+The mobile gaming traffic model has been checked against the IEEE 802.11-18/2009r6
+specification by comparing:
+
+* Default parameter values against Table 4-3 (Status Sync) in the specification
+* Largest Extreme Value distribution behavior for packet sizes and arrivals
+* Stage transition logic
+
+The test suite demonstrates that the model correctly implements the three-stage traffic
+pattern and produces traffic characteristics consistent with real-time mobile gaming
+applications.
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/doc/tgax-virtual-desktop-traffic.inc ns-3.47/src/applications/doc/tgax-virtual-desktop-traffic.inc
--- ns-3.46/src/applications/doc/tgax-virtual-desktop-traffic.inc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/doc/tgax-virtual-desktop-traffic.inc	2026-02-16 16:08:49.569229800 -0800
@@ -0,0 +1,255 @@
+TGax Virtual Desktop Infrastructure Traffic Model
+-------------------------------------------------
+
+This section describes the implementation of the |ns3| TGax Virtual Desktop Infrastructure (VDI)
+traffic generator model, which is based on the IEEE 802.11-14/0571r12 TGAX evaluation
+methodology [TGAX_EVAL]_.
+The TGax VDI traffic model is implemented in the ``src/applications/`` folder.
+
+Virtual Desktop Infrastructure (VDI) traffic is generated from a server and, in practice,
+may travel over multiple hops before arriving at an access point (AP) for transmission to
+stations (STAs).  VDI traffic statistics are asymmetric (between downlink (server to client
+display) and uplink (client display to server)).
+
+The model uses an exponential distribution for packet inter-arrival times and a normal
+distribution (including a bimodal distribution) for packet sizes, as specified in the
+IEEE 802.11-14/0571r12 evaluation methodology.
+
+Scope and Limitations
+~~~~~~~~~~~~~~~~~~~~~
+
+The VDI model implements the traffic generation aspects of the IEEE 802.11-14/0571r12
+specification. The following describes what is covered and what is not:
+
+**Supported Features:**
+
+- Exponential distribution for packet inter-arrival times
+- Uniform distribution for initial packet arrival (0-20ms)
+- Normal distribution for packet sizes
+- Bimodal normal distribution support for downlink packet sizes
+- TCP protocol (default, matching specification)
+- Configurable parameters for both downlink and uplink scenarios
+- Trace source for monitoring packet transmission
+
+**Known Limitations:**
+
+- (code review comment to resolve) Bimodal distribution mode selection uses equal probability instead
+  of weighted selection (70.6%/29.4%).
+  future versions.
+- (code review comment to resolve) Each application instance is unidirectional; bidirectional VDI simulation requires two
+  separate application instances and the uplink's parameters must be manually configured.
+
+Model Description
+~~~~~~~~~~~~~~~~~
+
+The ``TgaxVirtualDesktop`` application is a source application that generates VDI traffic
+patterns according to the IEEE 802.11-14/0571r12 evaluation methodology.
+
+**Traffic Generation Process:**
+
+1. **Initial Packet Arrival**: The first packet is scheduled after a uniformly distributed
+   delay in the range [0, 20ms], simulating random timing between client packet arrival
+   and frame boundaries.
+
+2. **Subsequent Packet Arrivals**: After the initial packet, inter-arrival times follow
+   an exponential distribution with direction-specific mean values.
+
+3. **Packet Size Generation**: Packet sizes are drawn from a normal distribution. For
+   downlink traffic, a bimodal normal distribution is used to model the mix of small
+   control packets and large display data packets.
+
+**Direction-Specific Parameters:**
+
+The specification defines different parameters for downlink and uplink traffic:
+
+*Downlink (AP to STA - Display Data):*
+
+.. list-table:: Downlink VDI Parameters
+   :header-rows: 1
+
+   * - Parameter
+     - Distribution
+     - Value
+   * - Initial packet arrival
+     - Uniform
+     - [0, 20] ms
+   * - Packet inter-arrival
+     - Exponential
+     - Mean = 60.2269 ms
+   * - Packet size
+     - Bimodal Normal
+     - Mode 1: mu=41.0, sigma=3.2 (weight 53.7/76.1)
+   * -
+     -
+     - Mode 2: mu=1478.3, sigma=11.6 (weight 22.4/76.1)
+
+*Uplink (STA to AP - Navigation/Feedback):*
+
+.. list-table:: Uplink VDI Parameters
+   :header-rows: 1
+
+   * - Parameter
+     - Distribution
+     - Value
+   * - Initial packet arrival
+     - Uniform
+     - [0, 20] ms
+   * - Packet inter-arrival
+     - Exponential
+     - Mean = 48.2870 ms
+   * - Packet size
+     - Normal
+     - mu=50.598, sigma=5.0753
+
+Configuration and Usage
+***********************
+
+The VDI traffic generator can be instantiated through the ``ApplicationHelper``.
+The default configuration matches the downlink specification.
+
+**Downlink Configuration (Default):**
+
+::
+
+  // Create nodes
+  NodeContainer nodes;
+  nodes.Create(2);
+
+  // Install Internet stack and assign IP addresses
+  InternetStackHelper internet;
+  internet.Install(nodes);
+
+  Ipv4AddressHelper ipv4;
+  ipv4.SetBase("10.0.0.0", "255.255.255.0");
+  ipv4.Assign(devices);
+
+  // Configure VDI application (downlink - default parameters)
+  ApplicationHelper sourceHelper(TgaxVirtualDesktop::GetTypeId());
+  sourceHelper.SetAttribute("Remote", AddressValue(InetSocketAddress(Ipv4Address("10.0.0.2"), 5000)));
+
+  auto sourceApps = sourceHelper.Install(nodes.Get(0));
+  sourceApps.Start(Seconds(1.0));
+  sourceApps.Stop(Seconds(11.0));
+
+  // Create receiver
+  PacketSinkHelper sinkHelper("ns3::TcpSocketFactory", InetSocketAddress(Ipv4Address::GetAny(), 5000));
+  auto sinkApps = sinkHelper.Install(nodes.Get(1));
+  sinkApps.Start(Seconds(0.0));
+  sinkApps.Stop(Seconds(12.0));
+
+**Uplink Configuration:**
+
+::
+
+  // Configure VDI application for uplink
+  ApplicationHelper sourceHelper(TgaxVirtualDesktop::GetTypeId());
+  sourceHelper.SetAttribute("Remote", AddressValue(InetSocketAddress(Ipv4Address("10.0.0.1"), 5001)));
+
+  // Set uplink inter-arrival time (mean 48.287 ms)
+  auto ulInterArrival = CreateObjectWithAttributes<ExponentialRandomVariable>(
+      "Mean", DoubleValue(48287000.0));  // nanoseconds
+  sourceHelper.SetAttribute("InterPacketArrivals", PointerValue(ulInterArrival));
+
+  // Set uplink packet size (normal distribution, mu=50.598, sigma=5.0753)
+  sourceHelper.SetAttribute("ParametersPacketSize", StringValue("50.598 5.0753"));
+
+  auto sourceApps = sourceHelper.Install(nodes.Get(1));  // STA node
+  sourceApps.Start(Seconds(1.0));
+  sourceApps.Stop(Seconds(11.0));
+
+Attributes
+~~~~~~~~~~
+
+The VDI traffic generator uses TCP by default.
+
+The following attributes control the behavior of the VDI traffic generator:
+
+**Protocol Configuration:**
+
+* ``Protocol``: The socket factory type to use. Default: ``ns3::TcpSocketFactory``
+* ``Remote``: The remote address and port for the VDI destination
+
+**Timing Parameters:**
+
+* ``InitialPacketArrival``: A uniform random variable for the initial packet arrival time.
+  Default: Uniform ranging from 0 to 20 ms
+* ``InterPacketArrivals``: An exponential random variable for inter-packet arrival times.
+  Default: Exponential with mean 60.2269ms (downlink specification)
+
+**Packet Size Parameters:**
+
+* ``ParametersPacketSize``: The mean and standard deviation for each mode of the (potentially
+  multimodal) normal distribution used to generate packet sizes. Format: "mean1 std1;mean2 std2"
+  for bimodal, or "mean std" for unimodal. Default: "41.0 3.2;1478.3 11.6" (downlink bimodal)
+
+Trace Sources
+~~~~~~~~~~~~~
+
+The VDI traffic generator provides a trace source for monitoring simulation behavior:
+
+**Tx:**
+
+::
+
+  typedef void (*TxTracedCallback)(Ptr<const Packet> packet);
+
+This trace source is fired when a packet is transmitted. It provides the packet being
+transmitted. This is useful for analyzing packet transmission patterns and sizes.
+
+Examples
+~~~~~~~~
+
+The ``tgax-virtual-desktop-example.cc`` program demonstrates basic usage of the VDI traffic
+generator. This example sets up a simple Wi-Fi network (AP and STA) with VDI traffic. The
+example supports downlink, uplink, and bidirectional traffic configurations.
+
+To run with downlink traffic (default):
+
+::
+
+  $ ./ns3 run tgax-virtual-desktop-example
+
+To run with uplink traffic:
+
+::
+
+  $ ./ns3 run "tgax-virtual-desktop-example --direction=uplink"
+
+To run with bidirectional traffic:
+
+::
+
+  $ ./ns3 run "tgax-virtual-desktop-example --direction=bidirectional"
+
+Tests
+~~~~~
+
+Unit tests for the VDI traffic model are provided in
+``src/applications/test/tgax-virtual-desktop-test-suite.cc``. These tests verify:
+
+* Downlink VDI traffic with default parameters
+* Uplink VDI traffic with custom parameters
+* Initial packet arrival within expected bounds (0-20ms)
+* Average packet inter-arrival time matches expectation
+* Average packet size matches expectation
+* All transmitted bytes are received
+
+To run the VDI traffic tests:
+
+::
+
+  $ ./test.py -s applications-tgax-virtual-desktop
+
+Verification
+~~~~~~~~~~~~
+
+The VDI traffic model has been checked against the IEEE 802.11-14/0571r12 specification
+by comparing:
+
+* Initial packet arrival distribution (Uniform [0, 20ms])
+* Packet inter-arrival time distribution (Exponential with direction-specific means)
+* Packet size distribution parameters against specification
+
+The test suite demonstrates that the model correctly implements the exponential inter-arrival
+behavior and normal packet size distributions.
+
